﻿	
	var raiz = null;
	var nodoSeleccionado = null;
	var filaSeleccionada = null;
	
	function action(nodo) {
		if (nodo.isDirectory()) {
			nodo.action();
			mostrarArbol();
		} else
			cargarFichero(nodo);
	}
	
	function dentro(elemento, nodo) {
		if (nodo != nodoSeleccionado)
			elemento.style.backgroundColor = COLOR_FILA_DENTRO;
	}
	
	function fuera(elemento, nodo) {
		if (nodo != nodoSeleccionado)
			elemento.style.backgroundColor = COLOR_FILA_FUERA;
	}
	
	function crearFila(nivel, nodo) {
		var tr = document.createElement(TAG_TR);
		var td = document.createElement(TAG_TD);
		td.noWrap = true;
		
		nodo.setRow(td);
		
		tr.style.cursor = CURSOR_MANO;
		tr.appendChild(td);
		
		tr.onmouseover = function() {
			if (!editorBloqueado)
				dentro(td, nodo);
		}
		
		tr.onmouseout = function() { 
			if (!editorBloqueado)
				fuera(td, nodo);
		}
		
		tr.ondblclick = function() { 
			if (!editorBloqueado) {
				action(nodo);
				
				bloquearBotones(false);
				nodoSeleccionado = nodo;
				
				var fila = nodo.getRow();
				filaSeleccionada = fila;
				filaSeleccionada.style.backgroundColor = COLOR_FILA_SELECC;
			}
		}
		
		tr.onclick = function() { 
			if (!editorBloqueado) {
				bloquearBotones(false);
				
				nodoSeleccionado = nodo;
				
				if (filaSeleccionada != null)
					filaSeleccionada.style.backgroundColor = COLOR_FILA_FUERA;
				
				filaSeleccionada = td;
				filaSeleccionada.style.backgroundColor = COLOR_FILA_SELECC;
			}
		}
		
		tr.onselectstart = function() {
			return false;
		}
		
		var espacio = EMPTY_STRING;
		
		for (var i = 0; i < nivel; i++)
			espacio += ESPACIO + ESPACIO + ESPACIO + ESPACIO;
		
		var vinculo = document.createTextNode(espacio + CARACTER_ARBOL);
		td.appendChild(vinculo);
		
		var imagen = document.createElement(TAG_IMG);
		
		imagen.onclick = function(evento) { 
			evento.stopPropagation();
		
			if (!editorBloqueado) {
				action(nodo);
				
				bloquearBotones(false);
				nodoSeleccionado = nodo;
				
				var fila = nodo.getRow();
				filaSeleccionada = fila;
				filaSeleccionada.style.backgroundColor = COLOR_FILA_SELECC;
			}
		}
		
		if (nodo.isDirectory()) {
			if (nodo.isOpen())
				imagen.setAttribute(ATTR_SRC, IMG_OPEN_DIR);
			else
				imagen.setAttribute(ATTR_SRC, IMG_CLOSE_DIR);
		} else
			imagen.setAttribute(ATTR_SRC, IMG_FICEHRO);
		
		td.appendChild(imagen);
		
		var etiqueta = document.createTextNode(ESPACIO + nodo.getName());
		td.appendChild(etiqueta);
		
		var arbol = document.getElementById(ELEMENTO_ARBOL);
		arbol.appendChild(tr);
	}
	
	function analizarNode(nodo, nivel) {
		crearFila(nivel, nodo);
		
		if (nodo.hasChildren()) {
			var hijos = nodo.getChildren();
			
			for (var i = 0; i < hijos.length; i++) {
				var hijo = hijos[i];
				
				if (hijo.getFather().isOpen())
					analizarNode(hijo, nivel + 1);
			}
		}
	}
	
	function borrarAbol() {
		vaciarElemento(ELEMENTO_ARBOL);
	}
	
	function mostrarArbol() {
		borrarAbol();
		
		analizarNode(raiz, 0);
	}
	
	function mostrarProyecto(proyecto) {
		raiz = proyecto
		
		mostrarArbol();
	}
	
	function crearArbol() {
		var arbol = document.createElement(TAG_TABLE);
		arbol.id  = ELEMENTO_ARBOL;
		arbol.style.padding    = 0;
		arbol.style.margin     = 0;
		arbol.style.fontFamily = FUENTE_VERDANA;
		arbol.style.fontSize   = TAMANO_FUENTE;
		arbol.style.width      = ANCHO_ARBOL;
		arbol.style.backgroundColor = COLOR_FILA_FUERA;
		
		return arbol;
	}
	