﻿	
	function crearArea() {
		var textContainer = document.createElement(TAG_DIV);
		textContainer.style.position = POSICION_ABSOLUTA; 
		textContainer.style.width    = (document.body.clientWidth - 213) + UNIDAD_MEDIDA;
		textContainer.style.height   = (document.body.clientHeight - 31) + UNIDAD_MEDIDA;
		textContainer.style.left     = X_TEXT_CONTAINER;
		textContainer.style.top      = Y_TEXT_CONTAINER;
		textContainer.style.overflow = ATTR_HIDDEN; 
		textContainer.style.backgroundColor = COLOR_TEXT_CONTAINER;
		
		var area = document.createElement(TAG_TEXTAREA);
		area.id  = ELEMENTO_AREA_TEXTO;
		area.setAttribute(ATTR_WRAP, ATTR_OFF);
		area.style.position   = POSICION_ABSOLUTA;
		area.style.left       = ANCHO_LINE_COUNTER;
		area.style.top        = 0;
		area.style.fontFamily = FUENTE_COURIER;
		area.style.fontSize   = TAMANO_FUENTE_AREA;
		area.style.width      = (document.body.clientWidth - 213 - parseInt(ANCHO_LINE_COUNTER)) + UNIDAD_MEDIDA;
		area.style.height     = (document.body.clientHeight - 31) + UNIDAD_MEDIDA;
		
		var lineCounter = document.createElement(TAG_DIV); 
		lineCounter.id  = ELEMENTO_LINE_COUNTER;
		lineCounter.style.position   = POSICION_ABSOLUTA;
		lineCounter.style.top        = TEXT_CONTAINER_OFFSET + UNIDAD_MEDIDA; 
		lineCounter.style.left       = 0;
		lineCounter.style.width      = ANCHO_LINE_COUNTER;
		lineCounter.style.textAlign  = ATTR_RIGHT; 
		lineCounter.style.fontFamily = FUENTE_COURIER;
		lineCounter.style.fontSize   = TAMANO_FUENTE_AREA;
		lineCounter.style.backgroundColor = COLOR_TEXT_CONTAINER;
		
		for (var i = 1; i < 10000; i++) {
			lineCounter.appendChild(document.createTextNode(i + ESPACIO));
			lineCounter.appendChild(document.createElement(TAG_BR));
		}
		
		setTextAreaListeners(area, lineCounter);
		
		textContainer.appendChild(lineCounter);
		textContainer.appendChild(area); 
		agregarAlDocumento(textContainer);
		
		var areaOculta = document.createElement(TAG_TEXTAREA);
		areaOculta.style.width  = 0;
		areaOculta.style.height = 0;
		agregarAlDocumento(areaOculta);
	}
	
	function changeLineCounter(lineCounter, area) {
		lineCounter.style.top = (TEXT_CONTAINER_OFFSET - area.scrollTop) + UNIDAD_MEDIDA;    
	}
	
	function setTextAreaListeners(area, lineCounter) {
	
		area.onkeydown = function (evento) {
			longitudAreaTexto = area.value.length;
			
			if (evento.keyCode == KEY_TAB)
				tabPress = 2;
			else if (evento.keyCode == TECLA_INTRO)
				introPress = contarEspacios(area);
		}
		
		area.onkeyup = function (evento) {
			if (introPress != 0) {
				insertarTexto(area, crearEspacios(introPress));
				introPress = 0;
			}
			
			if (longitudAreaTexto != area.value.length)
				areaModificada();
		}
		
		area.onblur = function() {
			tabPress--;
			
			if (tabPress >= 0) {
				insertarTexto(area, TAB_SPACE);
				area.focus();
			}
		}
		
		area.onscroll = function() {
			changeLineCounter(lineCounter, area);
		}
		
		area.onpaste = function() {
			changeLineCounter(lineCounter, area);
			areaModificada();
		}
	}
	
	function contarEspacios(area) {
		var res    = 0;
		var cadena = area.value.substring(0, area.selectionStart);
		var ultima = EMPTY_STRING;
		
		for (var i = cadena.length; i >= 0; i--) {
			var caracter = cadena.charAt(i);
			var codigo   = cadena.charCodeAt(i);
			
			if (codigo != 10)
				ultima = caracter + ultima;
			else
				break;
		}
		
		for (var j = 0; j < ultima.length; j++) {
			if (ultima.charCodeAt(j) == 32)
				res++;
			else
				break;
		}
		
		return res;
	}
	
	function crearEspacios(limite) {
		var res = EMPTY_STRING;
		
		for (var i = 0; i < limite; i++)
			res += ESPACIO;
		
		return res;
	}
	
	function insertarTexto(area, texto) {
		var scroll   = area.scrollTop;
		var posicion = area.selectionStart;
		
		var izquierda = (area.value).substring(0, posicion);  
		var derecha   = (area.value).substring(posicion, area.value.length); 
		
		area.value    = izquierda + texto + derecha;
		posicion = posicion + texto.length;
		area.selectionStart = posicion;
		area.selectionEnd   = posicion;
		area.focus();
			
		area.scrollTop = scroll;
	}
	
	function areaModificada() {
		if (ficheroActual != EMPTY_STRING) {
			ficheroModificado = true;
			bloquearBotonGuardar(false);
			actualizarInfoTamano();
		}
	}
	
	function focoEnArea() {
		var area = document.getElementById(ELEMENTO_AREA_TEXTO);
		area.focus();
	}
	
	function limpiarArea() {
		ficheroActual     = EMPTY_STRING;
		ficheroModificado = false;
		nodoSeleccionado  = null;
		filaSeleccionada  = null;
		
		cambiarInfoFichero(INFO_NOMBRE_FICHERO, ESPACIO);
		cambiarInfoFichero(INFO_TAMANO_FICHERO, ESPACIO);
		
		var area   = document.getElementById(ELEMENTO_AREA_TEXTO);
		area.value = EMPTY_STRING;
	}
	