﻿	
	function bloquearBotonGuardar(bloquear) {
		var botonGuardar = document.getElementById(BOTON_GUARDAR);
		
		if (bloquear)
			botonGuardar.setAttribute(ATTR_SRC, IMG_GUARDAR_OFF);
		else
			botonGuardar.setAttribute(ATTR_SRC, IMG_GUARDAR_ON);
	}
	
	function bloquearBotones(bloquear) {
		var botonNuevoDir  = document.getElementById(BOTON_NUEVO_DIR);
		var botonNuevoFic  = document.getElementById(BOTON_NUEVO_FIC);
		var botonRenombrar = document.getElementById(BOTON_RENOMBRAR);
		var botonEliminar  = document.getElementById(BOTON_ELIMINAR);
		
		if (bloquear) {
			botonNuevoDir.setAttribute(ATTR_SRC,  IMG_NEW_DIR_OFF);
			botonNuevoFic.setAttribute(ATTR_SRC,  IMG_NEW_FIC_OFF);
			botonRenombrar.setAttribute(ATTR_SRC, IMG_RENAME_OFF);
			botonEliminar.setAttribute(ATTR_SRC,  IMG_ELIMINAR_OFF);
		} else {
			botonNuevoDir.setAttribute(ATTR_SRC,  IMG_NEW_DIR_ON);
			botonNuevoFic.setAttribute(ATTR_SRC,  IMG_NEW_FIC_ON);
			botonRenombrar.setAttribute(ATTR_SRC, IMG_RENAME_ON);
			botonEliminar.setAttribute(ATTR_SRC,  IMG_ELIMINAR_ON);
		}
	}
	
	function aplicarBotonGuardar() {
		if (!editorBloqueado) {
		
			var botonGuardar = document.getElementById(BOTON_GUARDAR);
			
			if ((ficheroActual != EMPTY_STRING) && ficheroModificado && (botonGuardar.getAttribute(ATTR_SRC) == IMG_GUARDAR_ON))
				guardarFichero(null);
			else
				focoEnArea();
		}
	}
	
	function verificarNuevoElemento(nombre, tipo) {
		var valido  = true;
		var nodoRef = null;
		
		if (nodoSeleccionado.isDirectory())
			nodoRef = nodoSeleccionado;
		else
			nodoRef = nodoSeleccionado.getFather();
		
		if (nodoRef.hasChildren()) {
			var hijos = nodoRef.getChildren();
			
			for (var i = 0; i < hijos.length; i++) {
				var hijo = hijos[i];
				
				if (tipo == TIPO_FICHERO) {
					if (!hijo.isDirectory()) {
						if (hijo.getName() == nombre) {
							valido = false;
							break;
						}
					}
				} else if (tipo == TIPO_DIRECTORIO) {
					if (hijo.isDirectory()) {
						if (hijo.getName() == nombre) {
							valido = false;
							break;
						}
					}
				}
			}
		}
		
		return valido;
	}
	
	function crearFichero() {
		var botonNuevoFic = document.getElementById(BOTON_NUEVO_FIC);
	
		if ((!editorBloqueado) && (botonNuevoFic.getAttribute(ATTR_SRC) == IMG_NEW_FIC_ON)) {
			var nombre = preguntarNombre(TIPO_FICHERO);
			
			if (nombre != null) {
				if (verificarNuevoElemento(nombre, TIPO_FICHERO))
					aplicarCrearFichero(direccionBase() + PATH_SEPARATOR + nombre);
				else
					alert(MENSAJE_FICHERO_YA_EXISTE)
			} else
				focoEnArea();
		} else
			focoEnArea();
	}
	
	function aplicarCrearFichero(path) {
		if ((ficheroModificado) && (ficheroActual != EMPTY_STRING)) {
			if (confirm(MENSAJE_GUARDAR_CAMBIOS)) {
				var destino = function() {
					aplicarCrearFicheroEfectivo(path, true);
				}
				
				guardarFichero(destino);
			} else
				aplicarCrearFicheroEfectivo(path, false);
		} else
			aplicarCrearFicheroEfectivo(path, false);
	}
	
	function aplicarCrearFicheroEfectivo(path, ficheroGuardado) {
		if (ficheroGuardado) {
			mostrarMensaje(EMPTY_STRING);
			ficheroModificado = false;
			bloquearBotonGuardar(true);
			focoEnArea();
		}
		
		mostrarMensaje(MENSAJE_CREANDO_FICHERO);
		
		var area = document.getElementById(ELEMENTO_AREA_TEXTO);
		
		var parametros = new Parameters();
		parametros.add(PARAMETRO_OPERACION,  OPERACION_NUEVO_FIC);
		parametros.add(PARAMETRO_USUARIO,    usuario);
		parametros.add(PARAMETRO_CONTRASENA, contrasena);
		parametros.add(PARAMETRO_REFERENCIA, path);
		parametros.add(PARAMETRO_CONTENIDO,  area.value);
		
		Connection.send(DIR_SCRIPT, ficheroCreado, falloCrearFichero, parametros, RESULT_TYPE_XML);
	}
	
	function ficheroCreado(respuesta) {
		var nodo = respuesta.firstChild;
		
		if (nodo.nodeName == CREAR_FIC_OK)
			refrescarProyecto();
		else
			falloCrearFichero();
	}
	
	function crearDirectorio() {
		var botonNuevoDir = document.getElementById(BOTON_NUEVO_DIR);
	
		if ((!editorBloqueado) && (botonNuevoDir.getAttribute(ATTR_SRC) == IMG_NEW_DIR_ON)) {
			var nombre = preguntarNombre(TIPO_DIRECTORIO);
			
			if (nombre != null) {
				if (verificarNuevoElemento(nombre, TIPO_DIRECTORIO))
					aplicarCrearDirectorio(direccionBase() + PATH_SEPARATOR + nombre);
				else
					alert(MENSAJE_DIR_YA_EXISTE)
			} else
				focoEnArea();
		} else
			focoEnArea();
	}
	
	function aplicarCrearDirectorio(path) {
		if ((ficheroModificado) && (ficheroActual != EMPTY_STRING)) {
			if (confirm(MENSAJE_GUARDAR_CAMBIOS)) {
				var destino = function() {
					aplicarCrearDirectorioEfectivo(path, true);
				}
				
				guardarFichero(destino);
			} else
				aplicarCrearDirectorioEfectivo(path, false);
		} else
			aplicarCrearDirectorioEfectivo(path, false);
	}
	
	function aplicarCrearDirectorioEfectivo(path, ficheroGuardado) {
		if (ficheroGuardado) {
			mostrarMensaje(EMPTY_STRING);
			ficheroModificado = false;
			bloquearBotonGuardar(true);
			focoEnArea();
		}
		
		mostrarMensaje(MENSAJE_CREANDO_DIR);
		
		var parametros = new Parameters();
		parametros.add(PARAMETRO_OPERACION,  OPERACION_NUEVO_DIR);
		parametros.add(PARAMETRO_USUARIO,    usuario);
		parametros.add(PARAMETRO_CONTRASENA, contrasena);
		parametros.add(PARAMETRO_REFERENCIA, path);
		
		Connection.send(DIR_SCRIPT, directorioCreado, falloCrearDirectorio, parametros, RESULT_TYPE_XML);
	}
	
	function directorioCreado(respuesta) {
		var nodo = respuesta.firstChild;
		
		if (nodo.nodeName == CREAR_DIR_OK)
			refrescarProyecto();
		else
			falloCrearDirectorio();
	}
	
	function aplicarBotonRenombrar() {
		var botonRenombrar = document.getElementById(BOTON_RENOMBRAR);
		
		if ((!editorBloqueado) && (botonRenombrar.getAttribute(ATTR_SRC) == IMG_RENAME_ON)) {
			
			var destinoGuardado = function() {
				aplicarBotonRenombrarEfectivo(true);
			}
			
			if ((ficheroModificado) && (ficheroActual != EMPTY_STRING)) {
				if (confirm(MENSAJE_GUARDAR_CAMBIOS))
					guardarFichero(destinoGuardado);
				else
					aplicarBotonRenombrarEfectivo(false);
			} else
				aplicarBotonRenombrarEfectivo(false);
			
		} else
			focoEnArea();
	}
	
	function aplicarBotonRenombrarEfectivo(ficheroGuardado) {
		mostrarMensaje(EMPTY_STRING);
		
		if (ficheroGuardado) {
			ficheroModificado = false;
			bloquearBotonGuardar(true);
			focoEnArea();
		}
		
		var nuevo = EMPTY_STRING;
	
		if (nodoSeleccionado.isDirectory())
			nuevo = preguntarNombre(TIPO_DIRECTORIO);
		else
			nuevo = preguntarNombre(TIPO_FICHERO);
		
		if (nuevo != null)
			renombrarReferenciaServidor(nodoSeleccionado.getPath(), nuevo);
		else
			focoEnArea();
	}
	
	function renombrarReferenciaServidor(original, nuevo) {
		mostrarMensaje(MENSAJE_RENOMBRANDO_REF);
		
		var parametros = new Parameters();
		parametros.add(PARAMETRO_OPERACION,    OPERACION_RENOMBRAR);
		parametros.add(PARAMETRO_USUARIO,      usuario);
		parametros.add(PARAMETRO_CONTRASENA,   contrasena);
		parametros.add(PARAMETRO_REF_ORIGINAL, original);
		parametros.add(PARAMETRO_REF_NUEVA,    nuevo);
		
		Connection.send(DIR_SCRIPT, renombrarReferencia, falloRenombrar, parametros, RESULT_TYPE_XML);
	}
	
	function renombrarReferencia(respuesta) {
		mostrarMensaje(EMPTY_STRING);
		
		var nodo = respuesta.firstChild;
		
		if (nodo.nodeName == RENOMBRAR_OK)
			refrescarProyecto();
		else
			falloRenombrar();
			
		focoEnArea();
	}
	
	function aplicarBotonEliminar() {
		var botonEliminar = document.getElementById(BOTON_ELIMINAR);
		
		if ((!editorBloqueado) && (botonEliminar.getAttribute(ATTR_SRC) == IMG_ELIMINAR_ON)) {
			
			if (nodoSeleccionado.isRoot()) {
				alert(MENSAJE_NO_ELIMINAR_RAIZ);
				focoEnArea();
			} else {
				var mensaje = EMPTY_STRING;
				
				if (nodoSeleccionado.isDirectory())
					mensaje = MENSAJE_ELIMINAR_DIR;
				else
					mensaje = MENSAJE_ELIMINAR_FICHERO;
				
				if (confirm(mensaje))
					eliminarReferencia();
				else
					focoEnArea();
			}
		} else
			focoEnArea();
	}
	
	function eliminarNode(respuesta) {
		mostrarMensaje(EMPTY_STRING);
		
		var nodo = respuesta.firstChild;
		
		if (nodo.nodeName == ELIMINAR_OK) {
			nodoSeleccionado.deleteNode();
			mostrarArbol();
			limpiarArea();
			bloquearBotones(true);
		} else
			falloEliminar();
			
		focoEnArea();
	}
	
	function eliminarReferenciaServidor() {
		mostrarMensaje(MENSAJE_ELIMINANDO_REF);
		
		var parametros = new Parameters();
		parametros.add(PARAMETRO_OPERACION,  OPERACION_ELIMINAR);
		parametros.add(PARAMETRO_USUARIO,    usuario);
		parametros.add(PARAMETRO_CONTRASENA, contrasena);
		parametros.add(PARAMETRO_REFERENCIA, nodoSeleccionado.getPath());
		
		Connection.send(DIR_SCRIPT, eliminarNode, falloEliminar, parametros, RESULT_TYPE_XML);
	}
	
	function eliminarReferencia() {
		if ((ficheroModificado) && (ficheroActual != EMPTY_STRING)) {
			if (confirm(MENSAJE_GUARDAR_CAMBIOS))
				guardarFichero(eliminarReferenciaServidor);
			else
				eliminarReferenciaServidor();
		} else
			eliminarReferenciaServidor();
	}
	
	function aplicarRefrescarProyecto() {
		if (!editorBloqueado) {
		
			if ((ficheroModificado) && (ficheroActual != EMPTY_STRING)) {
				if (confirm(MENSAJE_GUARDAR_CAMBIOS))
					guardarFichero(refrescarProyecto);
				else
					refrescarProyecto();
			} else
				refrescarProyecto();
		}
	}
	
	function elementoListaSeleccionado() {
		var elemento = null;
		var lista = document.getElementById(ELEMENTO_LISTA_PROY);
		
		for (var i = 0; i < lista.options.length; i++){
			if (lista.options[i].selected) {
				elemento = lista.options[i];
				break;
			}
		}
		
		return elemento;
	}
	
	function refrescarProyecto() {
		mostrarMensaje(MENSAJE_REFRESCANDO_PROY);
		
		var elemento = elementoListaSeleccionado();
		
		var parametros = new Parameters();
		parametros.add(PARAMETRO_OPERACION,    OPERACION_REFRESCAR);
		parametros.add(PARAMETRO_USUARIO,      usuario);
		parametros.add(PARAMETRO_CONTRASENA,   contrasena);
		parametros.add(PARAMETRO_PROYECTO_NOM, elemento.firstChild.data);
		parametros.add(PARAMETRO_PROYECTO,     raiz.getPath());
		
		Connection.send(DIR_SCRIPT, respuestaRefrescarProyecto, falloRefrescar, parametros, RESULT_TYPE_XML);
	}
	
	function respuestaRefrescarProyecto(xml) {
		var nodo = xml.firstChild;
		var nuevaRaiz = new Node(nombreBase(nodo.getAttribute(NODE_ATTR_PATH)), nodo.getAttribute(NODE_ATTR_PATH), true, null);
		cargarProyecto(nodo, nuevaRaiz);
		proyectos.put(nuevaRaiz.getName(), nuevaRaiz);
		
		mostrarMensaje(EMPTY_STRING);
		mostrarProyecto(nuevaRaiz);
		limpiarArea();
		bloquearBotones(true);	
		focoEnArea();
	}
	
	function salirEditor() {
		if (!editorBloqueado) {
			if (confirm(MENSAJE_SALIR_EDITOR)) {
				if ((ficheroModificado) && (ficheroActual != EMPTY_STRING)) {
					if (confirm(MENSAJE_GUARDAR_CAMBIOS))
						guardarFichero(iniciarEditor);
					else
						iniciarEditor();
				} else
					iniciarEditor();
			} else
				focoEnArea();
		}
	}
	
	function crearBarra() {
		var barra = document.createElement(TAG_TABLE);
		barra.style.borderStyle = ATTR_RIDGE;
		barra.style.position    = POSICION_ABSOLUTA;
		barra.style.height      = ALTO_BARRA;
		barra.style.paddingLeft = PADDING_BARRA;
		barra.style.width       = (document.body.clientWidth - 213) + UNIDAD_MEDIDA;
		barra.style.left        = X_BARRA;
		barra.style.top         = 0;
		barra.style.backgroundColor = COLOR_FILA_DENTRO;
		
		var tr = document.createElement(TAG_TR);
		tr.style.height = ALTO_BARRA;
		barra.appendChild(tr);
		
		var td1 = document.createElement(TAG_TD);
		td1.style.height = ALTO_BARRA;
		td1.style.width  = ALTO_BARRA;
		tr.appendChild(td1);
		crearBotonBarra(td1, BOTON_GUARDAR, IMG_GUARDAR_OFF, TEXTO_BOTON_GUARDAR, aplicarBotonGuardar);
		
		var td2 = document.createElement(TAG_TD);
		td2.style.height = ALTO_BARRA;
		td2.style.width  = ALTO_BARRA;
		tr.appendChild(td2);
		crearBotonBarra(td2, BOTON_NUEVO_DIR, IMG_NEW_DIR_OFF, TEXTO_BOTON_NUEVO_DIR, crearDirectorio);
		
		var td3 = document.createElement(TAG_TD);
		td3.style.height = ALTO_BARRA;
		td3.style.width  = ALTO_BARRA;
		tr.appendChild(td3);
		crearBotonBarra(td3, BOTON_NUEVO_FIC, IMG_NEW_FIC_OFF, TEXTO_BOTON_NUEVO_FIC, crearFichero);
		
		var td4 = document.createElement(TAG_TD);
		td4.style.height = ALTO_BARRA;
		td4.style.width  = ALTO_BARRA;
		tr.appendChild(td4);
		crearBotonBarra(td4, BOTON_RENOMBRAR, IMG_RENAME_OFF, TEXTO_BOTON_RENOMBRAR, aplicarBotonRenombrar);
		
		var td5 = document.createElement(TAG_TD);
		td5.style.height = ALTO_BARRA;
		td5.style.width  = ALTO_BARRA;
		tr.appendChild(td5);
		crearBotonBarra(td5, BOTON_REFRESCAR, IMG_REFRESCAR, TEXTO_BOTON_REFRESCAR, aplicarRefrescarProyecto);
		
		var td6 = document.createElement(TAG_TD);
		td6.style.height = ALTO_BARRA;
		td6.style.width  = ALTO_BARRA;
		tr.appendChild(td6);
		crearBotonBarra(td6, BOTON_ELIMINAR, IMG_ELIMINAR_OFF, TEXTO_BOTON_ELIMINAR, aplicarBotonEliminar);
		
		var td7 = document.createElement(TAG_TD);
		td7.style.height = ALTO_BARRA;
		td7.style.width  = ALTO_BARRA;
		tr.appendChild(td7);
		crearBotonBarra(td7, BOTON_SALIR, IMG_SALIR, TEXTO_BOTON_SALIR, salirEditor);
		
		var anchoDisponible = (document.body.clientWidth - 213);
		
		var infoNombreFichero = crearElementoBarra(INFO_NOMBRE_FICHERO, 0, false);
		infoNombreFichero.style.paddingLeft = PADDING_INFO;
		tr.appendChild(infoNombreFichero);
		
		var infoTamanoFichero = crearElementoBarra(INFO_TAMANO_FICHERO, 100, true);
		tr.appendChild(infoTamanoFichero);
		
		agregarAlDocumento(barra);
		
		cambiarInfoFichero(INFO_NOMBRE_FICHERO, ESPACIO);
		cambiarInfoFichero(INFO_TAMANO_FICHERO, ESPACIO);
	}
	
	function crearBotonBarra(barra, id, grafico, texto, funcion) {
		var imagen = document.createElement(TAG_IMG);
		imagen.id  = id;
		imagen.setAttribute(ATTR_SRC, grafico);
		imagen.setAttribute(ATTR_TITLE, texto);
		imagen.style.width  = ANCHO_BOTON_BARRA;
		imagen.style.height = ALTO_BOTON_BARRA;
		imagen.style.cursor = CURSOR_MANO;
		
		imagen.onclick = function() {
			funcion();
		}
		
		barra.appendChild(imagen);
	}
	
	function crearElementoBarra(nombre, ancho, centrado) {
		var elemento = document.createElement(TAG_TD);
		elemento.id  = nombre;
		elemento.style.fontFamily = FUENTE_VERDANA;
		elemento.style.fontSize   = TAMANO_FUENTE;
		elemento.style.height     = ALTO_ELEMENTO_BARRA;
		elemento.style.backgroundColor = COLOR_CUADRO_LOGIN;
		
		if (centrado)
			elemento.style.textAlign = CENTRADO;
		
		if (ancho != 0)
			elemento.style.width = ancho + UNIDAD_MEDIDA;
		
		return elemento;
	}
	
	function cambiarInfoFichero(campo, valor) {
		vaciarElemento(campo);
		var elemento = document.getElementById(campo);
		elemento.appendChild(document.createTextNode(valor));
	}
	
	function calcularTamano(size) {
		var tamano = size;
		var unidad = UNIDAD_BYTES;
		
		if (tamano > 1024) {
			tamano = roundNumber(tamano / 1024, 2);
			unidad = UNIDAD_KB;
		}
		
		if (tamano > 1024) {
			tamano = roundNumber(tamano / 1024, 2);
			unidad = UNIDAD_MB;
		}
		
		return tamano + ESPACIO + unidad;
	}
	
	function actualizarInfoTamano() {
		var area = document.getElementById(ELEMENTO_AREA_TEXTO);
		cambiarInfoFichero(INFO_TAMANO_FICHERO, calcularTamano(area.value.length));
	}
	
	function falloCargar() {
		mostrarMensaje(EMPTY_STRING);
		
		cambiarInfoFichero(INFO_NOMBRE_FICHERO, ESPACIO);
		cambiarInfoFichero(INFO_TAMANO_FICHERO, ESPACIO);
		
		var area = document.getElementById(ELEMENTO_AREA_TEXTO);
		ficheroModificado = false;
		ficheroActual = EMPTY_STRING;
		area.value = EMPTY_STRING;
		
		alert(MENSAJE_FALLO_CARGAR);
	}
	
	function falloGuardar() {
		mostrarMensaje(EMPTY_STRING);
		alert(MENSAJE_FALLO_GUARDAR);
	}
	
	function falloEliminar() {
		mostrarMensaje(EMPTY_STRING);
		alert(MENSAJE_FALLO_ELIMINAR);
	}
	
	function falloRenombrar() {
		mostrarMensaje(EMPTY_STRING);
		alert(MENSAJE_FALLO_RENOMBRAR);
	}
	
	function falloCrearFichero() {
		mostrarMensaje(EMPTY_STRING);
		alert(MENSAJE_FALLO_CREAR_FIC);
	}
	
	function falloCrearDirectorio() {
		mostrarMensaje(EMPTY_STRING);
		alert(MENSAJE_FALLO_CREAR_DIR);
	}
	
	function falloRefrescar() {
		mostrarMensaje(EMPTY_STRING);
		alert(MENSAJE_FALLO_REFRESCAR);
	}
	