﻿	
	var proyectos = new Table();
	var ficheroActual = EMPTY_STRING;
	var usuario       = EMPTY_STRING;
	var contrasena    = EMPTY_STRING;
	var teclaCTRL     = false;
	var editorBloqueado   = false;
	var ficheroModificado = false;
	var tabPress   = 0;
	var introPress = 0;
	var longitudAreaTexto = 0;
	
	function nombreBase(path) {
		var separado = path.split(PATH_SEPARATOR);
			
		return (separado[separado.length - 1]);
	}
	
	function preguntarNombre(tipo) {
		var nombre = EMPTY_STRING;
		
		while (!((nombre == null) || (nombre != EMPTY_STRING)))
			nombre = prompt(MENSAJE_INGRESAR_NOMBRE + tipo + DOS_PUNTOS, EMPTY_STRING);
			
		return nombre;
	}
	
	function bloquearEditor(bloquear) {
		var listaProyectos = document.getElementById(ELEMENTO_LISTA_PROY);
		listaProyectos.disabled = bloquear;
		
		var area = document.getElementById(ELEMENTO_AREA_TEXTO);
		
		if (bloquear)
			area.setAttribute(ATTR_READ_ONLY, true);
		else
			area.removeAttribute(ATTR_READ_ONLY);
		
		editorBloqueado = bloquear;
	}
	
	function vaciarElemento(nombre) {
		var elemento = document.getElementById(nombre);
		
		while (elemento.hasChildNodes())
			elemento.removeChild(elemento.lastChild);
	}
	
	function agregarAlDocumento(elemento) {
		var cuerpo = document.getElementsByTagName(TAG_BODY)[0];
		cuerpo.appendChild(elemento);
	}
	
	function direccionBase() {
		var direccion = EMPTY_STRING;
		var father = nodoSeleccionado.getFather();
		
		if (!nodoSeleccionado.isDirectory() && (father != null))
			direccion = father.getPath();
		else
			direccion = nodoSeleccionado.getPath();
			
		return direccion;
	}
	
	function iniciarTeclasRapidas() {
		document.onkeyup = function(evento) {
			if	(evento.keyCode == KEY_CTRL)
				teclaCTRL = false;
		}
		
		document.onkeydown = function(evento) {
			if (evento.keyCode == KEY_CTRL) 
				teclaCTRL = true;
			
			if ((evento.keyCode == KEY_S) && teclaCTRL) {
				aplicarBotonGuardar();
				
				return false;
			}
			
			if ((evento.keyCode == KEY_UP) && teclaCTRL) {
				var area = document.getElementById(ELEMENTO_AREA_TEXTO);
				area.style.fontSize = ((parseInt(area.style.fontSize)) + 1) + UNIDAD_MEDIDA;
				
				var lineCounter	= document.getElementById(ELEMENTO_LINE_COUNTER);
				lineCounter.style.fontSize = ((parseInt(lineCounter.style.fontSize)) + 1) + UNIDAD_MEDIDA;
				
				return false;
			}
			
			if ((evento.keyCode == KEY_DOWN) && teclaCTRL) {
				var area = document.getElementById(ELEMENTO_AREA_TEXTO);
				area.style.fontSize = ((parseInt(area.style.fontSize)) - 1) + UNIDAD_MEDIDA;
				
				var lineCounter	= document.getElementById(ELEMENTO_LINE_COUNTER);
				lineCounter.style.fontSize = ((parseInt(lineCounter.style.fontSize)) - 1) + UNIDAD_MEDIDA;
				
				return false;
			}
		}
	}
	
	function iniciarVariables() {
		iniciarTeclasRapidas();
	
		proyectos = new Table();
		
		ficheroActual = EMPTY_STRING;
		usuario       = EMPTY_STRING;
		contrasena    = EMPTY_STRING;
		
		teclaCTRL = false;
		editorBloqueado   = false;
		ficheroModificado = false;
		
		tabPress = 0;
		introPress = 0;
		longitudAreaTexto = 0;
		
		raiz = null;
		nodoSeleccionado = null;
		filaSeleccionada = null;
	}
	
	function crearMensaje() {
		var mensajeEspera = document.createElement(TAG_TABLE);
		mensajeEspera.id  = ELEMENTO_MENSAJE;
		var tr = document.createElement(TAG_TR);
		var td = document.createElement(TAG_TD);
		td.id  = ELEMENTO_CONT_MENSAJE;
		
		mensajeEspera.style.borderStyle = ATTR_RIDGE;
		mensajeEspera.style.fontFamily  = FUENTE_VERDANA;
		mensajeEspera.style.fontSize    = TAMANO_FUENTE_MSG;
		mensajeEspera.style.fontWeight  = NEGRITA;
		mensajeEspera.style.visibility  = ATTR_HIDDEN;
		mensajeEspera.style.position    = POSICION_ABSOLUTA;
		mensajeEspera.style.left        = X_MENSAJE;
		mensajeEspera.style.top         = Y_MENSAJE;
		mensajeEspera.style.backgroundColor = COLOR_FONDO_MENSAJE;
		
		td.appendChild(document.createTextNode(EMPTY_STRING));
		tr.appendChild(td);
		mensajeEspera.appendChild(tr);
		
		agregarAlDocumento(mensajeEspera);
	}
	
	function mostrarMensaje(texto) {
		var mostrar = (texto != EMPTY_STRING);
		
		bloquearEditor(mostrar);
		
		var mensajeEspera = document.getElementById(ELEMENTO_MENSAJE);
		
		if (mostrar)
			mensajeEspera.style.visibility = ATTR_VISIBLE;
		else
			mensajeEspera.style.visibility = ATTR_HIDDEN;
		
		vaciarElemento(ELEMENTO_CONT_MENSAJE);
		var td = document.getElementById(ELEMENTO_CONT_MENSAJE);
		
		var imagen = document.createElement(TAG_IMG);
		imagen.setAttribute(ATTR_SRC, IMG_WAIT);
		imagen.style.position = POSICION_RELATIVA;
		imagen.style.left     = X_WAIT;
		imagen.style.top      = Y_WAIT;
		td.appendChild(imagen);
		
		td.appendChild(document.createTextNode(ESPACIO + ESPACIO + texto + ESPACIO));
	}
	
	function cargarPantalla(xml) {
		crearExplorador(cargarProyectos(xml));
		crearArea();
		crearBarra();
		crearMensaje();
		cambioProyecto();
		
		var listaProyectos = document.getElementById(ELEMENTO_LISTA_PROY);
		mostrarProyecto(proyectos.get(listaProyectos.value));
	}
	
	function roundNumber(num, dec) {
		return Math.round(num * Math.pow(10,dec)) / Math.pow(10,dec);
	}
	
	function guardarFichero(destino) {
		var area = document.getElementById(ELEMENTO_AREA_TEXTO);
		mostrarMensaje(MENSAJE_GUARDANDO_FICHERO);
		
		var parametros = new Parameters();
		parametros.add(PARAMETRO_OPERACION,  OPERACION_GUARDAR);
		parametros.add(PARAMETRO_USUARIO,    usuario);
		parametros.add(PARAMETRO_CONTRASENA, contrasena);
		parametros.add(PARAMETRO_FICHERO,    ficheroActual);
		parametros.add(PARAMETRO_CONTENIDO,  area.value);
		
		if (destino == null)
			Connection.send(DIR_SCRIPT, ficheroGuardado, falloGuardar, parametros, RESULT_TYPE_XML);
		else
			Connection.send(DIR_SCRIPT, destino, falloGuardar, parametros, RESULT_TYPE_XML);
	}
	
	function mostrarFichero(texto){
		var area = document.getElementById(ELEMENTO_AREA_TEXTO);
		bloquearBotonGuardar(true);
		mostrarMensaje(EMPTY_STRING);
		
		ficheroModificado = false;
		area.value = texto;
		
		actualizarInfoTamano();
	}
	
	function accionesGuardarFichero() {
		mostrarMensaje(EMPTY_STRING);
		ficheroModificado = false;
		bloquearBotonGuardar(true);
		focoEnArea();
	}
	
	function ficheroGuardado(respuesta) {
		var nodo = respuesta.firstChild;
		
		if (nodo.nodeName == GUARDAR_FIC_OK)
			accionesGuardarFichero();
		else
			falloGuardar();
	}
	