﻿	
	function cargarProyectos(xml) {
		var listaProyectos = document.createElement(TAG_SELECT);
		listaProyectos.id  = ELEMENTO_LISTA_PROY;
		listaProyectos.style.width      = ANCHO_LISTA_PROY;
		listaProyectos.style.height     = ALTO_LISTA_PROY;
		listaProyectos.style.fontSize   = TAMANO_FUENTE_LIS;
		listaProyectos.style.fontFamily = FUENTE_VERDANA;
		listaProyectos.style.fontWeight = NEGRITA;
		
		listaProyectos.onchange = function() {
			cambioProyecto();
			mostrarProyecto(proyectos.get(listaProyectos.value));
		}
		
		var hijos = xml.childNodes;
		
		for (var i = 0; i < hijos.length; i++) {
			var nodo = hijos[i];
			
			var raiz = new Node(nombreBase(nodo.getAttribute(NODE_ATTR_PATH)), nodo.getAttribute(NODE_ATTR_PATH), true, null);
			cargarProyecto(nodo, raiz);
			agregarProyecto(listaProyectos, raiz, nodo.getAttribute(NODE_ATTR_NAME));
		}
		
		return listaProyectos;
	}
	
	function cargarProyecto(xml, raiz) {
		var hijos = xml.childNodes;
		
		for (var i = 0; i < hijos.length; i++) {
			var nodo  = hijos[i];
			var nuevo =  null;
			
			if (nodo.nodeName == NODE_ATTR_TYPE)
				nuevo = new Node(nodo.getAttribute(NODE_ATTR_NAME), nodo.getAttribute(NODE_ATTR_PATH), true, raiz);
			else
				nuevo = new Node(nodo.getAttribute(NODE_ATTR_NAME), nodo.getAttribute(NODE_ATTR_PATH), false, raiz);
			
			cargarProyecto(nodo, nuevo);
		}
	}
	
	function agregarProyecto(listaProyectos, proyecto, nombreProyecto) {
		proyectos.put(proyecto.getName(), proyecto);
		
		var elemento = document.createElement(TAG_OPTION);
		
		var nombre = document.createTextNode(nombreProyecto);
		elemento.appendChild(nombre);
		elemento.value = proyecto.getName();
		
		listaProyectos.appendChild(elemento);
	}
	
	function crearExplorador(listaProyectos) {
		var explorador = document.createElement(TAG_TABLE);
		explorador.style.borderStyle = ATTR_RIDGE;
		explorador.style.position    = POSICION_ABSOLUTA;
		explorador.style.height      = ALTO_EXPLORADOR;
		explorador.style.width       = ANCHO_EXPLORADOR;
		explorador.style.left        = 0;
		explorador.style.top         = 0;
		explorador.style.backgroundColor = COLOR_FILA_DENTRO;
		
		var tr = document.createElement(TAG_TR);
		tr.style.height = ALTO_EXPLORADOR;
		explorador.appendChild(tr);
		
		var td2 = document.createElement(TAG_TD);
		td2.style.height = ALTO_EXPLORADOR;
		tr.appendChild(td2);
		td2.appendChild(listaProyectos);
		
		var div = document.createElement(TAG_DIV);
		div.style.position  = POSICION_ABSOLUTA;
		div.style.height    = (document.body.clientHeight - 31) + UNIDAD_MEDIDA;
		div.style.width     = ANCHO_CONT_ARBOL;
		div.style.top       = Y_CONT_ARBOL;
		div.style.left      = 0;
		div.style.overflowX = ATTR_AUTO;
		div.style.overflowY = ATTR_AUTO;
		div.style.backgroundColor = COLOR_FILA_FUERA;
		div.appendChild(crearArbol());		

		agregarAlDocumento(explorador);
		agregarAlDocumento(div);
	}
	
	function leerProyectos() {
		var parametros = new Parameters();
		parametros.add(PARAMETRO_OPERACION, OPERACION_PROYECTOS);
		parametros.add(PARAMETRO_USUARIO,    usuario);
		parametros.add(PARAMETRO_CONTRASENA, contrasena);
	
		Connection.send(DIR_SCRIPT, cargarPantalla, falloLeerProyectos, parametros, RESULT_TYPE_XML);
	}
	
	function falloLeerProyectos() {
		alert(MENSAJE_FALLO_PROYECTOS);
	}
	
	function cambioProyecto() {
		if ((ficheroModificado) && (ficheroActual != EMPTY_STRING)) {
			if (confirm(MENSAJE_GUARDAR_CAMBIOS))
				guardarFichero(continuarCambioProyecto);
			else
				continuarCambioProyecto();
		} else
			continuarCambioProyecto();
	}
	
	function continuarCambioProyecto() {
		accionesGuardarFichero();
		
		bloquearBotones(true);
		bloquearBotonGuardar(true);
		
		limpiarArea();
	}
	
	function cargarFichero(nodo) {
		if ((ficheroModificado) && (ficheroActual != EMPTY_STRING)) {
			if (confirm(MENSAJE_GUARDAR_CAMBIOS)) {
				var destino = function() {
					continuarCargaFichero(nodo);
				}
				
				guardarFichero(destino);
			} else
				continuarCargaFichero(nodo);
		} else
			continuarCargaFichero(nodo);
	}
	
	function continuarCargaFichero(nodo) {
		accionesGuardarFichero();
		
		ficheroActual = nodo.getPath();
		
		cambiarInfoFichero(INFO_NOMBRE_FICHERO, nodo.getInternalPath());
		mostrarMensaje(MENSAJE_CARGANDO_FICHERO);
		
		var parametros = new Parameters();
		parametros.add(PARAMETRO_OPERACION,  OPERACION_CARGAR);
		parametros.add(PARAMETRO_USUARIO,    usuario);
		parametros.add(PARAMETRO_CONTRASENA, contrasena);
		parametros.add(PARAMETRO_FICHERO,    ficheroActual);
		
		Connection.send(DIR_SCRIPT, mostrarFichero, falloCargar, parametros, RESULT_TYPE_TEXT);
	}
	