﻿	
	function iniciarEditor() {
		iniciarVariables();
		vaciarCuerpo();
		
		var html = document.getElementsByTagName(TAG_HTML)[0];
		html.style.overflow = ATTR_HIDDEN;
		
		crearPantallaLogin();
	}
	
	function colorFondo(color) {
		var body = document.getElementsByTagName(TAG_BODY)[0];
		body.style.backgroundColor = color;
	}
	
	function vaciarCuerpo() {
		var body = document.getElementsByTagName(TAG_BODY)[0];
		colorFondo(COLOR_FILA_DENTRO);
		
		while (body.hasChildNodes())
			body.removeChild(body.lastChild);
	}
	
	function crearPantallaLogin() {
		var login = document.createElement(TAG_TABLE);
		login.style.backgroundColor = COLOR_CUADRO_LOGIN;
		login.style.borderStyle = ATTR_RIDGE;
		login.style.fontFamily  = FUENTE_VERDANA;
		login.style.fontSize    = TAMANO_FUENTE_LOG;
		login.style.fontWeight  = NEGRITA;
		login.style.width       = ANCHO_CUADRO_LOG;
		login.style.padding     = ESPACIO_LOGIN;
		login.style.position    = POSICION_ABSOLUTA;
		login.style.left        = ((document.body.clientWidth/2) - 130) + UNIDAD_MEDIDA;
		login.style.top         = Y_LOGIN;
		
		var lineaUsuario = document.createElement(TAG_TR);
		var lineaContrasena = document.createElement(TAG_TR);
		var lineaBoton = document.createElement(TAG_TR);
		
		var tdEtiquetaUsuario = document.createElement(TAG_TD);
		var tdEtiquetaContrasena = document.createElement(TAG_TD);
		var tdBoton = document.createElement(TAG_TD);
		
		var etiquetaUsuario = document.createTextNode(ETIQUETA_USUARIO);
		var etiquetaContrasena = document.createTextNode(ETIQUETA_CONTRASENA);
		
		var campoUsuario = document.createElement(TAG_INPUT);
		campoUsuario.id  = ELEMENTO_CAMPO_USUARIO;
		campoUsuario.style.fontFamily = FUENTE_VERDANA;
		campoUsuario.style.fontSize   = TAMANO_FUENTE_LOG;
		campoUsuario.style.marginLeft = MARGIN_LOGIN;
		campoUsuario.style.width      = ANCHO_CAMPO_LOGIN;
		
		var campoContrasena = document.createElement(TAG_INPUT);
		campoContrasena.id  = ELEMENTO_CAMPO_CONTRASENA;
		campoContrasena.setAttribute(ATTR_TYPE, ATTR_PASSWORD);
		campoContrasena.style.fontFamily = FUENTE_VERDANA;
		campoContrasena.style.fontSize   = TAMANO_FUENTE_LOG;
		campoContrasena.style.marginLeft = MARGIN_LOGIN;
		campoContrasena.style.width      = ANCHO_CAMPO_LOGIN;
		
		campoUsuario.onkeypress = function(evento) {
			if (evento.keyCode == TECLA_INTRO)
				comprobarLogin(campoUsuario, campoContrasena);
		}
		
		campoContrasena.onkeypress = function(evento) {
			if (evento.keyCode == TECLA_INTRO)
				comprobarLogin(campoUsuario, campoContrasena);
		}
		
		tdEtiquetaUsuario.appendChild(etiquetaUsuario);
		lineaUsuario.appendChild(tdEtiquetaUsuario);
		lineaUsuario.appendChild(campoUsuario);
		login.appendChild(lineaUsuario);
		
		tdEtiquetaContrasena.appendChild(etiquetaContrasena);
		lineaContrasena.appendChild(tdEtiquetaContrasena);
		lineaContrasena.appendChild(campoContrasena);
		login.appendChild(lineaContrasena);
		
		var contenedorBoton = document.createElement(TAG_CENTER);
		
		var boton = document.createElement(TAG_INPUT);
		boton.id  = ELEMENTO_BOTON_LOGIN;
		boton.style.fontFamily = FUENTE_VERDANA;
		boton.style.fontSize   = TAMANO_FUENTE_LOG;
		boton.style.fontWeight = NEGRITA;
		boton.style.padding    = PADDING_LOGIN;
		boton.style.width      = ANCHO_BOTON_LOGIN;
		boton.style.height     = ALTO_BOTON_LOGIN;
		
		boton.setAttribute(ATTR_TYPE,  ATTR_SUBMIT);
		boton.setAttribute(ATTR_VALUE, ETIQUETA_LOGIN);
		
		boton.onclick = function() {
			comprobarLogin(campoUsuario, campoContrasena);
		}
		
		contenedorBoton.appendChild(boton);
		
		tdBoton.appendChild(contenedorBoton);
		tdBoton.setAttribute(ATTR_COLSPAN, 2);
		tdBoton.style.paddingTop = PADDING_TOP_LOG;
		
		lineaBoton.appendChild(tdBoton);
		login.appendChild(lineaBoton);
		
		agregarAlDocumento(login);
		
		campoUsuario.focus();
	}
	
	function bloquearLogin(bloquear) {
		var campoUsuario    = document.getElementById(ELEMENTO_CAMPO_USUARIO);
		var campoContrasena = document.getElementById(ELEMENTO_CAMPO_CONTRASENA);
		var botonLogin      = document.getElementById(ELEMENTO_BOTON_LOGIN);
		
		campoUsuario.disabled    = bloquear;
		campoContrasena.disabled = bloquear;
		botonLogin.disabled      = bloquear;
	}
	
	function comprobarLogin(campoUsuario, campoContrasena) {
		if (campoUsuario.value == EMPTY_STRING) {
			alert(MENSAJE_FALTA_USUARIO)
			campoUsuario.focus();
		} else if (campoContrasena.value == EMPTY_STRING) {
			alert(MENSAJE_FALTA_CONTRASENA)
			campoContrasena.focus();
		} else {
			bloquearLogin(true);
			realizarLogin(campoUsuario.value, campoContrasena.value);
		}
	}
	
	function realizarLogin(valorUsuario, valorCotrasena) {
		usuario    = valorUsuario;
		contrasena = valorCotrasena;
		
		var parametros = new Parameters();
		parametros.add(PARAMETRO_OPERACION,  OPERACION_LOGIN);
		parametros.add(PARAMETRO_USUARIO,    usuario);
		parametros.add(PARAMETRO_CONTRASENA, contrasena);
		
		Connection.send(DIR_SCRIPT, respuestaLoging, falloLogin, parametros, RESULT_TYPE_XML);
	}
	
	function respuestaLoging(respuesta) {
		var nodo = respuesta.firstChild;
		
		if (nodo.nodeName == LOGIN_OK) {
			bloquearLogin(false);
			vaciarCuerpo();
			colorFondo(COLOR_FILA_FUERA);
			leerProyectos();
		} else
			loginInvalido();
	}
	
	function loginInvalido() {
		usuario    = EMPTY_STRING;
		contrasena = EMPTY_STRING;
		
		alert(MENSAJE_LOGIN_INVALIDO);
		
		bloquearLogin(false);
		campoContrasena.focus();
	}
	
	function falloLogin() {
		usuario    = EMPTY_STRING;
		contrasena = EMPTY_STRING;
		
		alert(MENSAJE_FALLO_LOGIN);
		bloquearLogin(false);
	}
	