﻿	
	/****************************************************
	 * 	Script:			table.js						*
	 *	Description:	Table data structure			*
	 *	Author:			Max Power						*
	 *	Version:		1.0								*
	 *	Date:			01/03/2010						*
	 ****************************************************/
	
	/**
	 *	Class:			Table
	 *	Description:	Table data structure
	 **/
	
	function Table() {
		
		this.data = new Object();
		
		/**
		 *	Put a value indexed by a key
		**/
		
		this.put = function (key, value) {
			this.data[key] = value;
		}
		
		/**
		 *	Returns the value associated to the key
		**/
		
		this.get = function (key) {
			return this.data[key];
		}
		
		/**
		 *	Removes the value associated to the key
		**/
		
		this.remove = function (key) {
			delete this.data[key];
		}
		
		/**
		 *	Returns true if the table is empty
		**/
		
		this.isEmpty = function () {
			var empty = true;
			
			for (var index in this.data) {
				empty = false;
				break;
			}
		
			return empty;
		}
		
		/**
		 *	Returns an array that contains the values of the table
		**/
		
		this.values = function () {
			var result = new Array();
			
			for (var index in this.data)
				result.push(this.data[index])
			
			return result;
		}
		
		/**
		 *	Returns an array that contains the keys of the table
		**/
		
		this.keys = function () {
			var result = new Array();
			
			for (var index in this.data)
				result.push(index)
			
			return result;
		}
		
		/**
		 *	Returns true if the table contains the key
		**/
		
		this.containsKey = function (key) {
			var result = false;
			
			for (var index in this.data) {
				if (key == index) {
					result = true;
					break;
				}
			}
			
			return result;
		}
		
		/**
		 *	Returns true if the table contains the value
		**/
		
		this.containsValue = function (value) {
			var result = false;
			
			for (var index in this.data) {
				if (value == this.data[index]) {
					result = true;
					break;
				}
			}
			
			return result;
		}
	}
	